unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ImgList, StdCtrls, Buttons, Gauges, ComCtrls;

//=============================================================================
type
    TScore = packed record
        Score: Integer;
        Level: Integer;
        Time : ShortString;
        _OldPos: Integer;
    end;
    PScore = ^TScore;

//=============================================================================
type
  TMainForm = class(TForm)
    Panel1: TPanel;
    BoxGame: TPaintBox;
    ListIcon: TImageList;
    ListIcon2: TImageList;
    Panel2: TPanel;
    Panel3: TPanel;
    Image1: TImage;
    LblKind1: TLabel;
    LblKind2: TLabel;
    LblKind3: TLabel;
    LblKind4: TLabel;
    LblKind5: TLabel;
    LblKind6: TLabel;
    LblKind7: TLabel;
    Panel4: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    LblHiScore: TLabel;
    LblScore: TLabel;
    Panel5: TPanel;
    LblNext: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    LblLevel: TLabel;
    Label11: TLabel;
    LblHint: TLabel;
    GaugeTimer: TGauge;    PnlTitle: TPanel;
    Shape1: TShape;
    Image2: TImage;
    Label4: TLabel;
    LblLevel2: TLabel;
    Label12: TLabel;
    ImgBonus2: TImage;
    Label13: TLabel;
    Label14: TLabel;
    LblNext2: TLabel;
    Label10: TLabel;
    ImgBonus: TImage;
    Shape2: TShape;
    Label5: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    PnlGameOver: TPanel;
    Label19: TLabel;
    Image3: TImage;
    Image4: TImage;
    Label20: TLabel;
    ImglStatus: TImageList;
    LstvRank: TListView;
    Image5: TImage;
    Image6: TImage;
    Image7: TImage;
    Image8: TImage;
    Image9: TImage;
    Image10: TImage;
    Image11: TImage;
    Label3: TLabel;
    Label21: TLabel;
    SpeedButton1: TSpeedButton;
    procedure BoxGamePaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BoxGameMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormPaint(Sender: TObject);
    procedure Shape1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormShow(Sender: TObject);
    procedure PnlGameOverMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton1Click(Sender: TObject);
  private
    FBitmap: TBitmap;
    procedure DrawTextBitmapCenter(const AText: String);
  private
    DataFileName: String;
    FScores: TList;
    procedure ResetPosition();
    procedure ClearScoreFromLast(const LeftCount: integer);
    procedure DispScore();
    procedure DispScoreData();
  public
    function GetHiScore(): Integer;
  end;

var
  MainForm: TMainForm;

implementation

uses
    SquareGrid, VertialField, Info;

const
    MAX_COUNT = 10;
    IMG_NEW  = 0;
    IMG_KEEP = 1;
    IMG_DOWN = 2;

{$R *.dfm}

//////
//-----------------------------------------------------------------------------
//  Sɕ`
procedure TMainForm.DrawTextBitmapCenter(const AText: String);

    procedure DrawTextCenter(AHDC: HDC; ARect: TRect; AText: String);
    begin
        DrawText(AHDC, PChar(AText), -1, ARect, DT_SINGLELINE or DT_CENTER or DT_VCENTER);
    end;

var
    LRect: TRect;
begin
    LRect := BoxGame.ClientRect;
    FBitmap.Canvas.Brush.Style := bsClear;

    FBitmap.Canvas.Font.Color := clWhite;
    OffsetRect(LRect, -2, -2);
    DrawTextCenter(FBitmap.Canvas.Handle, LRect, AText);
    OffsetRect(LRect, +4,  0);
    DrawTextCenter(FBitmap.Canvas.Handle, LRect, AText);
    OffsetRect(LRect,  0, +4);
    DrawTextCenter(FBitmap.Canvas.Handle, LRect, AText);
    OffsetRect(LRect, -4,  0);
    DrawTextCenter(FBitmap.Canvas.Handle, LRect, AText);
    FBitmap.Canvas.Font.Color := clBlack;
    OffsetRect(LRect, +2, -2);
    DrawTextCenter(FBitmap.Canvas.Handle, LRect, AText);

    FBitmap.Canvas.Brush.Style := bsSolid;
end;

//-----------------------------------------------------------------------------
procedure TMainForm.BoxGamePaint(Sender: TObject);
var
    i: Integer;
    j: Integer;
    LRect: TRect;
    LText: String;
begin
    FBitmap.Canvas.Brush.Color := clWhite;
    FBitmap.Canvas.FillRect(BoxGame.ClientRect);
    Square.DrawGrid(FBitmap.Canvas.Handle, 0, 0);

    for i := 0 to Square.ColCount - 1 do
    begin
        for j := 0 to Square.RowCount - 1 do
        begin
            LRect := Square.Cell(i, j);

            //  IZ͘g
            if (i = GameThread.Select.Y) and (j = GameThread.Select.X) then
            begin
                FBitmap.Canvas.Pen.Color := clBlack;
                FBitmap.Canvas.Brush.Color := clMaroon;
                FBitmap.Canvas.Rectangle(LRect);
            end;

            //  Z̓eC[WXgoĕ`

            //  ʏ
            if (GameThread.Status[j][i] = STATUS_NONE) then
            begin
                ListIcon.Draw(FBitmap.Canvas, LRect.Left, LRect.Top,
                                GameThread.Field[j][i]);
            end
            //  钼Ôт
            else
            if (GameThread.Status[j][i] in [STATUS_DELETE, STATUS_NOMOVE]) then
            begin
                ListIcon.Draw(FBitmap.Canvas, LRect.Left, LRect.Top,
                                GameThread.Field[j][i] + FIELD_SIZE);
            end
            //  
            else
            begin
                ListIcon2.Draw(FBitmap.Canvas, LRect.Left, LRect.Top, 0);
            end
        end;
    end;

    //  \
    if (GameThread.Mode = mNoMove) then
    begin
        LText := '!!! NO MOVE !!!';
    end
    else
    if (GameThread.ChainCounter > 0) then
    begin
        LText := Format('CHAIN BONUS X %d', [GameThread.ChainCounter + 1]);
    end;
    DrawTextBitmapCenter(LText);

    //  `
    BitBlt(BoxGame.Canvas.Handle, 0, 0, BoxGame.Width, BoxGame.Height,
            FBitmap.Canvas.Handle, 0, 0, SRCCOPY);

    //  x
    LblNext.Caption := IntToStr(GameThread.Threshold);
    LblLevel.Caption := IntToStr(GameThread.Level);

    //  XRA
    LblHiScore.Caption := Format('%9.9d', [GetHiScore()]);
    LblScore.Caption := Format('%9.9d', [GameThread.Score]);
    if (LblScore.Caption > LblHiScore.Caption) then
    begin
        LblHiScore.Caption := LblScore.Caption;
    end;

    //  ^C}[
    GaugeTimer.MaxValue := GameThread.LevelTimer;
    GaugeTimer.Progress := GameThread.Timer;

    //  ޕʃJE^XV
    LblKind1.Caption := IntToStr(GameThread.KindCounter[1]);
    LblKind2.Caption := IntToStr(GameThread.KindCounter[2]);
    LblKind3.Caption := IntToStr(GameThread.KindCounter[3]);
    LblKind4.Caption := IntToStr(GameThread.KindCounter[4]);
    LblKind5.Caption := IntToStr(GameThread.KindCounter[5]);
    LblKind6.Caption := IntToStr(GameThread.KindCounter[6]);
    LblKind7.Caption := IntToStr(GameThread.KindCounter[7]);
end;

//-----------------------------------------------------------------------------
//  XRA\[gp
function CompareScore(Item1, Item2: Pointer): Integer;
var
    S1, S2: PScore;
begin
    S1 := PScore(Item1);
    S2 := PScore(Item2);
    Result := (S2^.Score - S1^.Score);
    if (Result = 0) then Result := CompareStr(S1^.Time, S2^.Time);
end;

//-----------------------------------------------------------------------------
//  XRǍ݂̏ʂݒ
procedure TMainForm.ResetPosition();
var
    i: integer;
    Score: PScore;
begin
    for i := 0 to FScores.Count - 1 do
    begin
        Score := PScore(FScores.Items[i]);
        Score^._OldPos := i;
    end;
end;

//-----------------------------------------------------------------------------
//  XRAf[^w茏cČ납NA
procedure TMainForm.ClearScoreFromLast(const LeftCount: integer);
var
    Score: PScore;
begin
    while FScores.Count > LeftCount do
    begin
        Score := PScore(FScores.Last);
        Dispose(Score);
        FScores.Delete(FScores.Count - 1);
    end;
end;

//-----------------------------------------------------------------------------
//  nCXRA擾
function TMainForm.GetHiScore(): Integer;
var
    Score: PScore;
begin
    //  nCXRAXV
    if (FScores.Count > 0) then
    begin
        Score := PScore(FScores.Items[0]);
        Result := Score^.Score;
    end
    else
        Result := 0
    ;
end;

//-----------------------------------------------------------------------------
//  XRA`
procedure TMainForm.DispScoreData();
var
    i: Integer;
    Score: PScore;
    ListItem: TListItem;
begin
    //  ACeNA
    LstvRank.Items.Clear;
    //  qgc\
    for i := 0 to FScores.Count - 1 do
    begin
        //  f[^o
        Score := PScore(FScores.Items[i]);
        //  ACeǉ
        ListItem := LstvRank.Items.Add();
        ListItem.Caption := Format(' %2d', [i + 1]);
        //  ԃ`FbN
        if (Score^._OldPos = -1) then ListItem.ImageIndex := IMG_NEW
        else if (Score^._OldPos = i) then ListItem.ImageIndex := IMG_KEEP
        else if (Score^._OldPos < i) then ListItem.ImageIndex := IMG_DOWN
        ;
        ListItem.OverlayIndex := ListItem.ImageIndex;
        ListItem.StateIndex := ListItem.ImageIndex;
        //  ̑f[^
        ListItem.SubItems.Add(Format('%9.9d', [Score^.Score]));
        ListItem.SubItems.Add(Format('%2.2d', [Score^.Level]));
        ListItem.SubItems.Add(Score^.Time);
    end;
end;

//-----------------------------------------------------------------------------
//  XRA\
procedure TMainForm.DispScore();
var
    NewScoreTime: string;
    Score: PScore;
begin
    if (GameThread.Score > 0) then
    begin
        //  ݎێ
        NewScoreTime := FormatDateTime('yyyy/mm/dd/hh:nn:ss', Now);
        //  Vzm
        New(Score);
        //  lZbg
        Score^.Score := GameThread.Score;
        Score^.Level := GameThread.Level;
        Score^.Time := NewScoreTime;
        Score^._OldPos := -1;
        //  Xgɒǉ
        FScores.Add(Score);
        //  \[g
        FScores.Sort(CompareScore);
        //  11ʈȍ~͓z폜
        ClearScoreFromLast(MAX_COUNT);
    end;
    
    //  Xgr[NA
    DispScoreData();
end;

//-----------------------------------------------------------------------------
procedure TMainForm.FormCreate(Sender: TObject);
var
    F: TextFile;
    S, Temp: string;
    SL: TStringList;
    Score: PScore;
begin
    //  h~
    FBitmap := TBitmap.Create();
    FBitmap.Width := Screen.Width;
    FBitmap.Height := Screen.Height;
    FBitmap.Canvas.Font.Assign(Self.Font);
    FBitmap.Canvas.Font.Size := 18;
    BoxGame.ControlStyle := BoxGame.ControlStyle + [csOpaque];

    //  Q[tB[hݒ
    Square.LineSize := 3;
    Square.LineColor := clWhite;
    Square.CellSize := ListIcon.Width;
    BoxGame.Width := Square.Width;
    BoxGame.Height := Square.Height;

    //  nCXRAǂݍ
    FScores := TList.Create;
    SL := TStringList.Create;
    try
        //  f[^t@C̃pX
        DataFileName := ChangeFileExt(ParamStr(0), '.dat');
        //  f[^t@CΓǂݍ
        if FileExists(DataFileName) then
        begin
            AssignFile(F, DataFileName);
            Reset(F);
            try
                while not Eof(F) do
                begin
                    Readln(F, S);
                    SL.CommaText := S;
                    if SL.Count > 2 then
                    begin
                        //  \̂mۂ
                        New(Score);
                        //  XRAZbg
                        Temp := SL.Strings[0];
                        Score^.Score := StrToIntDef(Temp, 0);
                        //  xZbg
                        Temp := SL.Strings[1];
                        Score^.Level := StrToIntDef(Temp, 0);
                        //  Zbg
                        Temp := SL.Strings[2];
                        Score^.Time := Temp;
                        //  Xgɒǉ
                        FScores.Add(Score);
                    end;
                end;
            finally
                CloseFile(F);
            end;
        end;
        //  XRAɃ\[g
        FScores.Sort(CompareScore);
        //  ʃZbg
        ResetPosition();
    finally
        SL.Free;
    end;

    //  Q[Xbh쐬
    GameThread := TGameThread.Create();
end;

//-----------------------------------------------------------------------------
procedure TMainForm.FormDestroy(Sender: TObject);
var
    i: integer;
    F: TextFile;
    Score: PScore;
begin
    GameThread.Terminate();
    GameThread.Free();
    FBitmap.Free();

    //  XRA̕ۑ
    AssignFile(F, DataFileName);
    Rewrite(F);
    try
        for i := 0 to FScores.Count - 1 do
        begin
            Score := PScore(FScores.Items[i]);
            Writeln(F, Format('%d,%d,%s', [Score^.Score, Score^.Level, Score^.Time]));
        end;
    finally
        CloseFile(F);
    end;

    //  XRAf[^j
    ClearScoreFromLast(0);
    FScores.Free;
end;

//-----------------------------------------------------------------------------
procedure TMainForm.BoxGameMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
    LPoint: TPoint;
    LDirection: TDirection;
begin
    //  Q[
    if (not GameThread.Suspended) then
    begin
        if (Button = mbLeft) then
        begin
            LPoint := Square.MouseToCell(X, Y);
            GameThread.SetPoint(Point(LPoint.Y, LPoint.X));
        end
        else
        if (Button = mbRight) then
        begin
            GameThread.GetHint(LPoint, LDirection);
            LblHint.Caption := Format('MOVE (%d,%d) %s',
                                [LPoint.X + 1, LPoint.Y + 1, DIR_TEXT[LDirection]]);
        end;
    end;
end;

//-----------------------------------------------------------------------------
procedure TMainForm.FormPaint(Sender: TObject);
begin
    //  ʍĕ`
    BoxGame.Repaint();

    //  xAbvʕ\
    if (GameThread.LevelUpped) then
    begin
        LblNext2.Caption := IntToStr(GameThread.Threshold);
        LblLevel2.Caption := IntToStr(GameThread.Level);
        ImgBonus.Picture.Bitmap := nil;
        ListIcon.GetBitmap(GameThread.BonusKind, ImgBonus.Picture.Bitmap);
        ImgBonus2.Picture.Bitmap := nil;
        ListIcon.GetBitmap(GameThread.BonusKind, ImgBonus2.Picture.Bitmap);

        PnlTitle.Show();
    end

    //  Q[I[o[
    else
    if (GameThread.GameOvered) then
    begin
        DispScore();
        PnlGameOver.Show();
    end;
end;

//-----------------------------------------------------------------------------
procedure TMainForm.FormShow(Sender: TObject);
begin
    PnlGameOver.Left := 0;
    PnlGameOver.Top := 0;

    LblNext2.Caption := IntToStr(GameThread.Threshold);
    LblLevel2.Caption := IntToStr(GameThread.Level);
    ListIcon.GetBitmap(GameThread.BonusKind, ImgBonus.Picture.Bitmap);
    ListIcon.GetBitmap(GameThread.BonusKind, ImgBonus2.Picture.Bitmap);
    DispScore();
end;

//-----------------------------------------------------------------------------
procedure TMainForm.Shape1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    PnlTitle.Hide();
    GameThread.Resume();
end;

//-----------------------------------------------------------------------------
procedure TMainForm.PnlGameOverMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    GameThread.Prepare();
    PnlGameOver.Hide();

    LblNext2.Caption := IntToStr(GameThread.Threshold);
    LblLevel2.Caption := IntToStr(GameThread.Level);
    ImgBonus.Picture.Bitmap := nil;
    ListIcon.GetBitmap(GameThread.BonusKind, ImgBonus.Picture.Bitmap);
    ImgBonus2.Picture.Bitmap := nil;
    ListIcon.GetBitmap(GameThread.BonusKind, ImgBonus2.Picture.Bitmap);

    PnlTitle.Show();

    //  ʃZbg
    ResetPosition();
end;

procedure TMainForm.SpeedButton1Click(Sender: TObject);
begin
    OpenInfoForm();
end;

end.
